#include <pthread.h>
#include <stdio.h>

#define SIZE 1024
#define PARALLEL

float kontostand = 1000.00;

void *einzahler (void *argumente) {
	int i;
	float tmp;
	for (i=0; i<SIZE; i++) {
		tmp = kontostand;
		tmp = tmp+250.0;
		kontostand = tmp;
	}
	return NULL;
}

void *abheber (void *argumente) {
	int i;
	float tmp;
	for (i=0; i<SIZE; i++) {
		tmp = kontostand;
		tmp = tmp-250.0;
		kontostand = tmp;
	}
	return NULL;
}

int main () {
	printf ("Kontostand Anfang: %12.2f EUR\n", kontostand);

#ifdef PARALLEL
	// parallele Ausfuehrung
	pthread_t threads[200];
	for (int i=0; i<100; i++) {
		pthread_create (&threads[2*i],   NULL, einzahler, NULL);
		pthread_create (&threads[2*i+1], NULL, abheber,   NULL);
	}
	for (int i=0; i<200; i++) {
		pthread_join (threads[i], NULL);
	}
#else
	// sequentielle Ausfuehrung
	pthread_t thread1, thread2;
	for (int i=0; i<100; i++) {
		pthread_create (&thread1, NULL, einzahler, NULL);
		pthread_join (thread1, NULL);
		pthread_create (&thread2, NULL, abheber,   NULL);
		pthread_join (thread2, NULL);
	}
#endif

	printf ("Kontostand Ende:   %12.2f EUR\n", kontostand);
	return 0;
}