#include <stdio.h>
#include <unistd.h>
#include <sys/wait.h>
#include <stdlib.h>

int main () {
	int pid = fork();
	int exitcode;
	if (pid == 0) {
		// Kindprozess
		sleep (2);
		printf ("Bin das Kind! Meine PID ist %d.\n", getpid());
		exit(77);
	} else {
		// Parent-Prozess
		printf ("Bin das Parent! Mein Kind hat PID %d.\n", pid);
		wait(&exitcode);
		printf ("Kind hatte exitcode = %d.\n", exitcode >> 8);
	}
}